--- /dev/null
- # try looking for a gitgui-* tag, or fallback onto the
- # distributed version file.
+#!/bin/sh
+
+GVF=GIT-VERSION-FILE
+DEF_VER=0.6.GITGUI
+
+LF='
+'
+
+tree_search ()
+{
+ head=$1
+ tree=$2
+ for p in $(git rev-list --parents --max-count=1 $head 2>/dev/null)
+ do
+ test $tree = $(git rev-parse $p^{tree} 2>/dev/null) &&
+ vn=$(git describe --abbrev=4 $p 2>/dev/null) &&
+ case "$vn" in
+ gitgui-[0-9]*) echo $vn; break;;
+ esac
+ done
+}
+
++# Always use the tarball version file if found, just
++# in case we are somehow contained in a larger git
++# repository that doesn't actually track our state.
++# (At least one package manager is doing this.)
++#
+# We may be a subproject, so try looking for the merge
+# commit that supplied this directory content if we are
+# not at the toplevel. We probably will always be the
+# second parent in the commit, but we shouldn't rely on
+# that fact.
+#
+# If we are at the toplevel or the merge assumption fails
- if prefix="$(git rev-parse --show-prefix 2>/dev/null)"
++# try looking for a gitgui-* tag.
+
- elif test -f version
- then
- VN=$(cat version) || VN="$DEF_VER"
++if test -f version &&
++ VN=$(cat version)
++then
++ : happy
++elif prefix="$(git rev-parse --show-prefix 2>/dev/null)"
+ test -n "$prefix" &&
+ head=$(git rev-list --max-count=1 HEAD -- . 2>/dev/null) &&
+ tree=$(git rev-parse --verify "HEAD:$prefix" 2>/dev/null) &&
+ VN=$(tree_search $head $tree)
+ case "$VN" in
+ gitgui-[0-9]*) : happy ;;
+ *) (exit 1) ;;
+ esac
+then
+ VN=$(echo "$VN" | sed -e 's/^gitgui-//;s/-/./g');
+elif VN=$(git describe --abbrev=4 HEAD 2>/dev/null) &&
+ case "$VN" in
+ gitgui-[0-9]*) : happy ;;
+ *) (exit 1) ;;
+ esac
+then
+ VN=$(echo "$VN" | sed -e 's/^gitgui-//;s/-/./g');
+else
+ VN="$DEF_VER"
+fi
+
+dirty=$(sh -c 'git diff-index --name-only HEAD' 2>/dev/null) || dirty=
+case "$dirty" in
+'')
+ ;;
+*)
+ VN="$VN-dirty" ;;
+esac
+
+if test -r $GVF
+then
+ VC=$(sed -e 's/^GITGUI_VERSION = //' <$GVF)
+else
+ VC=unset
+fi
+test "$VN" = "$VC" || {
+ echo >&2 "GITGUI_VERSION = $VN"
+ echo "GITGUI_VERSION = $VN" >$GVF
+}
+
+
--- /dev/null
- SCRIPT_SH = git-gui.sh
+all::
+
+GIT-VERSION-FILE: .FORCE-GIT-VERSION-FILE
+ @$(SHELL_PATH) ./GIT-VERSION-GEN
+-include GIT-VERSION-FILE
+
- ALL_PROGRAMS = $(GITGUI_BUILT_INS) $(patsubst %.sh,%,$(SCRIPT_SH))
+GITGUI_BUILT_INS = git-citool
- $(patsubst %.sh,%,$(SCRIPT_SH)) : % : %.sh
++ALL_PROGRAMS = git-gui $(GITGUI_BUILT_INS)
+
+ifndef SHELL_PATH
+ SHELL_PATH = /bin/sh
+endif
+
+ifndef gitexecdir
+ gitexecdir := $(shell git --exec-path)
+endif
+
+ifndef INSTALL
+ INSTALL = install
+endif
+
+DESTDIR_SQ = $(subst ','\'',$(DESTDIR))
+gitexecdir_SQ = $(subst ','\'',$(gitexecdir))
+SHELL_PATH_SQ = $(subst ','\'',$(SHELL_PATH))
+
- sed -e '1s|#!.*/sh|#!$(SHELL_PATH_SQ)|' \
++git-gui: git-gui.sh GIT-VERSION-FILE CREDITS-FILE
+ rm -f $@ $@+
- # These can record GITGUI_VERSION
- $(patsubst %.sh,%,$(SCRIPT_SH)): GIT-VERSION-FILE
-
++ sed -n \
++ -e '1s|#!.*/sh|#!$(SHELL_PATH_SQ)|' \
+ -e 's/@@GITGUI_VERSION@@/$(GITGUI_VERSION)/g' \
++ -e '1,/^set gitgui_credits /p' \
+ $@.sh >$@+
++ cat CREDITS-FILE >>$@+
++ sed -e '1,/^set gitgui_credits /d' $@.sh >>$@+
+ chmod +x $@+
+ mv $@+ $@
+
++CREDITS-FILE: CREDITS-GEN .FORCE-CREDITS-FILE
++ $(SHELL_PATH) ./CREDITS-GEN
++
+$(GITGUI_BUILT_INS): git-gui
+ rm -f $@ && ln git-gui $@
+
- dist-version:
+all:: $(ALL_PROGRAMS)
+
+install: all
+ $(INSTALL) -d -m755 '$(DESTDIR_SQ)$(gitexecdir_SQ)'
+ $(INSTALL) git-gui '$(DESTDIR_SQ)$(gitexecdir_SQ)'
+ $(foreach p,$(GITGUI_BUILT_INS), rm -f '$(DESTDIR_SQ)$(gitexecdir_SQ)/$p' && ln '$(DESTDIR_SQ)$(gitexecdir_SQ)/git-gui' '$(DESTDIR_SQ)$(gitexecdir_SQ)/$p' ;)
+
- rm -f $(ALL_PROGRAMS) GIT-VERSION-FILE
++dist-version: CREDITS-FILE
+ @mkdir -p $(TARDIR)
+ @echo $(GITGUI_VERSION) > $(TARDIR)/version
++ @cat CREDITS-FILE > $(TARDIR)/credits
+
+clean::
++ rm -f $(ALL_PROGRAMS) GIT-VERSION-FILE CREDITS-FILE
+
+.PHONY: all install dist-version clean
+.PHONY: .FORCE-GIT-VERSION-FILE
++.PHONY: .FORCE-CREDITS-FILE